function DLC_Freezing_Analyze_R1(tracking_data,video_data)
%%%%%% This code is used to load the DLC traking output file and calculate
%%%%%% the freezing level according to the change of pixels. The
%%%%%% threshold is set 3% .  The vidoe file is also load to generate new
%%%%%% overlay video for tracing quality inspection. 
%%%%%% by kaiyu@cshl.edu
%
raw_data=xlsread(tracking_data);
[path name ext]=fileparts(tracking_data);
cd(path);
[N_frame,N_points_temp]=size(raw_data);
N_points=(N_points_temp-1)/3;

%% 
for n=1:N_frame
    poly_temp_x=raw_data(n, 2:3:41);
    poly_temp_x(8:14)=flip(poly_temp_x(8:14));
    poly_temp_y=raw_data(n,3:3:42);
    poly_temp_y(8:14)=flip(poly_temp_y(8:14));
    poly_temp=polyshape(poly_temp_x,poly_temp_y,'Simplify',true);
    polygons{n}=poly_temp;
end

%% Calculate Freezing 
   alpha_area=ones(N_frame,1);
for n=2:N_frame
  
    alpha_area(n)=area(intersect(polygons{n-1},polygons{n}))/area(polygons{n-1});
end
alpha_area=1-alpha_area;
frame_rate=30;
x=linspace(0,N_frame/frame_rate,N_frame);


alpha_area_smoothed=smooth(alpha_area,10); 
threshold=0.03;
figure;hold on;
plot(x,alpha_area_smoothed);ylim([0 1]);
yline(threshold,'r'); hold off;
saveas(gcf,[name 'DLC_freezing'],'jpg');

freeze_backup=zeros(N_frame,1);
freeze_backup(alpha_area_smoothed<threshold)=1;

freeze=zeros(N_frame,1);
freeze(alpha_area_smoothed<threshold)=1;

for n=30:N_frame-30
    temp=0;
   for m=1:30
      temp2=freeze(n-30+m:n+m-1);
      if sum(temp2)==30
          temp=temp+1;
       break
      else
          temp=temp;
      end
   end
   if temp==0
      freeze(n)=0;
   end
end
 
nTrials=round(length(freeze)/2700 ); 
for n=1:nTrials
    nStart=1+(n-1)*2700;
    nStop=900+(n-1)*2700;
    nStart2=901+(n-1)*2700;
    nStop2=1800+(n-1)*2700;
    FreezeLevel(n,1)=100*sum(freeze(nStart:nStop))/900;
    FreezeLevel(n,2)=100*sum(freeze(nStart2:nStop2))/900;
end

%%
cd(path);
save([name 'DLC_Freezing_Analyze_R1']);
