%% Coding direction analysis
clear all

%% put all neurons together ----- neuron pooled %%
% D1, D2 activity dataset
t1=0;      % t1,t2 time window 
t2=30;

RepeatNum = 10;
neuron_num_ratio = 0.25;
N_total = size(D1,1);
N_num = round(N_total*neuron_num_ratio);

EDistanceSum1 = [];
EDistanceSum2 = [];
RatioSum = [];
for k=1:RepeatNum
    
    ind_sel = randsample(N_total,N_num);
    
    d1 = D1(ind_sel,:);
    d2 = D2(ind_sel,:);
    
    data_diff = d1-d2;
    cdirect = mean(data_diff(:,t1:t2),2);
    cd_norm = normc(cdirect);    
    cd1 = d1'*cd_norm;
    cd2 = d2'*cd_norm;
    
    EDistanceSum1 = [EDistanceSum1;cd1'];
    EDistanceSum2 = [EDistanceSum2;cd2'];
    
    TotalVariance = sum(var([d1(:,t1:t2)';d2(:,t1:t2)']));
    CDVariance = var([cd1(t1:t2,1);cd2(t1:t2,1)]);

    RatioSum(k) = CDVariance/TotalVariance;
    
end

ve_mean = mean(RatioSum);
ve_sem = std(RatioSum)/sqrt(length(RatioSum));
