function PhotometryAnalysis_Reward_Laser(DataPath,MaxTrials,FrameRate)
%%
for nSubject=18:24
nSubject=23;
DataPath=['Z:\kai Data in CSHL 2\kai-DAT-b\kai-DAT-b' num2str(nSubject) '\Reward_Laser_Session1'];

Temp=rdir([char(DataPath) '\*.mat']);
BpodData=Temp(1).name; load(BpodData);
[Path name ext]=fileparts(BpodData);
FigureName=name;

Temp=rdir([char(DataPath) '\*.csv']);
if contains(Temp(1).name,'Trigger')
    TriggerDataPath=Temp(1).name;
    PhotometryDataPath=Temp(2).name;
elseif contains(Temp(1).name,'trigger')
    TriggerDataPath=Temp(1).name;
    PhotometryDataPath=Temp(2).name;
else   
TriggerDataPath=Temp(2).name;
PhotometryDataPath=Temp(1).name;
end
MaxTrials=80;
FrameRate =20; 

if SessionData.nTrials>MaxTrials
    nTrials=MaxTrials;
else
    nTrials=SessionData.nTrials;
end
Duration_Trial=20;
Pre_CS=10;

%%

Trigger=importdata(TriggerDataPath);
Trigger=Trigger(:,1);
iTrigger=[];
iTrigger(1)=Trigger(1);
j=2;
for i=2:length(Trigger)-1
    temp1=Trigger(i);
    temp2=max(Trigger(i+1));
    if temp2-temp1>20
      iTrigger(j)=temp2;
      j=j+1;
    end

nTrigger=length(iTrigger);

if nTrigger<nTrials
    nTrials=nTrigger;
end

raw_data=importdata(PhotometryDataPath);
iSignal=raw_data(:,1);
SignalTemp=raw_data(:,2);

SignalTemp=SignalTemp-mean(SignalTemp(1:50));% Removal of residual autopholuorepho signal)

Channels=2;
n=round(length(SignalTemp)/2)-1;
iSignal=iSignal(1:2*n);
SignalTemp=SignalTemp(1:2*n);

SignalTemp2=SignalTemp(1:2*n);

SignalTemp2=reshape(SignalTemp2,2,n);


iSignal=reshape(iSignal,Channels,n);
SignalTemp=reshape(SignalTemp,Channels,n);
iSignal=iSignal';
SignalTemp=SignalTemp';

iSignal_Ch1=iSignal(:,1);
Signal_Ch1=SignalTemp(:,1);

for i=1:nTrials
    temp1=round(iTrigger(i));
    temp2=round(iSignal_Ch1);
    temp3=find(temp2>temp1);
    temp4=temp3(1);
    signal_Ch1(:,i)=Signal_Ch1(temp4:temp4+Duration_Trial*FrameRate-1);
end
  
    Signal_Ch1=signal_Ch1(:);
    
 iSignal_Ch2=iSignal(:,2);
Signal_Ch2=SignalTemp(:,2);

for i=1:nTrials
    temp1=round(iTrigger(i));
    temp2=round(iSignal_Ch2);
    temp3=find(temp2>temp1);
    temp4=temp3(1);
    signal_Ch2(:,i)=Signal_Ch2(temp4:temp4+Duration_Trial*FrameRate-1);
end
    Signal_Ch2=signal_Ch2(:);
    
    
[Path name ext]=fileparts(PhotometryDataPath);

 %%
 close all; 
 
cd(Path);
mkdir('Output4');
cd('Output4');
if mean(Signal_Ch1)>mean(Signal_Ch2)
iSignal_Ch3=iSignal(:,1);
Signal_Ch3=SignalTemp(:,1);
iSignal_Ch3_control=iSignal(:,2);
Signal_Ch3_control=SignalTemp(:,2);
else
iSignal_Ch3=iSignal(:,2);
Signal_Ch3=SignalTemp(:,2);
iSignal_Ch3_control=iSignal(:,1);
Signal_Ch3_control=SignalTemp(:,1);
end


Lick_Index=1;
for n=1:nTrials
    if isfield(SessionData.RawEvents.Trial{1,n}.Events,'Port8Out')
       
        Licks{n}=SessionData.RawEvents.Trial{1,n}.Events.Port8Out;
        nLicks=length(SessionData.RawEvents.Trial{1,n}.Events.Port8Out);
        Trial_Index(Lick_Index:Lick_Index+nLicks-1)=n;
        Lick_Index=Lick_Index+nLicks;
    else
        Licks{n}=[]; 
    end
end
HitTrials=[];MissTrials=[];m=0;
for n=1:nTrials
   temp=Licks{1,n};
   temp2=find(temp>Pre_CS,1);
   if ~isempty(temp2)
       m=m+1;
       HitTrials=[HitTrials,n];
       temp3=temp(temp2);
        temp4=1000*(temp3-Pre_CS);
        Offset(n)=temp4;
   else
       MissTrials=[MissTrials,n];
       Offset(n)=0;
   end
end

Lick_Index=1;Licks={};Trial_Index=[];
for m=1:length(HitTrials)
     n=HitTrials(m);
    if isfield(SessionData.RawEvents.Trial{1,n}.Events,'Port8Out')
       
        Licks{m}=SessionData.RawEvents.Trial{1,n}.Events.Port8Out-Offset(n)/1000;
        nLicks=length(SessionData.RawEvents.Trial{1,n}.Events.Port8Out);
        Trial_Index(Lick_Index:Lick_Index+nLicks-1)=m;
        Lick_Index=Lick_Index+nLicks;
    else
        Licks{m}=[]; 
    end
end

figure;
sz = 5;
scatter (cell2mat(Licks)-10,Trial_Index,sz,'filled','s','Markerfacecolor', 'black');
axis ([-4, 6,0,length(HitTrials)]);
title(name,'Interpreter','none');
xlabel('Time (s)');
ylabel ('Trials');
saveas(gcf,[name '-Raster'], 'jpg');
saveas(gcf,[name '-Raster'], 'fig');

x=linspace(-4,6,100);
y1=hist(cell2mat(Licks)-10,x)/10;

figure;
bar(x,y1,'k');
axis ([-4 6 0 8]);
xlabel('Time (s)');
ylabel('Lick rate (Hz)');
title(name,'Interpreter','none');
saveas(gcf,[name '-PSTH'], 'jpg');
saveas(gcf,[name '-PSTH'], 'fig');


iTriggerHit=iTrigger(HitTrials);

for i=1:nTrials
    
    temp1=round(iTrigger(i)+Offset(i));
    temp2=round(iSignal_Ch3);
    temp3=find(temp2>temp1);
    temp4=temp3(1);
    signal_Ch3(:,i)=Signal_Ch3(temp4:temp4+Duration_Trial*FrameRate-1);
end

for i=1:nTrials
    temp1=round(iTrigger(i)+Offset(i));
    temp2=round(iSignal_Ch3_control);
    temp3=find(temp2>temp1);
    temp4=temp3(1);
    signal_Ch3_control(:,i)=Signal_Ch3_control(temp4:temp4+Duration_Trial*FrameRate-1);
end


Signal_Ch3=signal_Ch3(:);
Control_Signal=signal_Ch3_control(:);

Signal=Signal_Ch3;
signal=signal_Ch3;

roiDATA=Signal;
tau1 = round(FrameRate *0.75 ); %these two parameters you can change (refer to Helmchen Delta F image i showed you)
tau2 = round(FrameRate * 3);
roi_fzero = zeros(size(roiDATA)); %this should be the size of your data matrix    
avg_mat =movmean(roiDATA,tau1); %this filters the data a bit
     
     for t = 1:size(roiDATA,1)
         roi_fzero(t,:) = min(avg_mat(max(1,t-tau2):t,:));
     end 

  dF= (roiDATA-roi_fzero)./roi_fzero;
  df=reshape(dF, size(signal));

roiDATA=Control_Signal;
tau1 = round(FrameRate *0.75 ); %these two parameters you can change (refer to Helmchen Delta F image i showed you)
tau2 = round(FrameRate * 3);
roi_fzero = zeros(size(roiDATA)); %this should be the size of your data matrix    
avg_mat =movmean(roiDATA,tau1); %this filters the data a bit
     
     for t = 1:size(roiDATA,1)
         roi_fzero(t,:) = min(avg_mat(max(1,t-tau2):t,:));
     end 

  dF= (roiDATA-roi_fzero)./roi_fzero;
  control_df=reshape(dF, size(signal));
 
 x1=linspace(0+1/FrameRate,length(iTriggerHit)*Duration_Trial,Duration_Trial*length(HitTrials)*FrameRate);
 x2=linspace(0-Pre_CS+1/FrameRate,Duration_Trial-Pre_CS,Duration_Trial*FrameRate);
 pLaser=SessionData.pLaser;
A_in=find(pLaser==1);
B_in=find(pLaser==0);

A=intersect(HitTrials,A_in);
B=intersect(HitTrials,B_in);

if ~isempty(A)
figure; heatmap2(df(:,A)',x2,[],[],'ColorMap',@jet);title(['Laser-' FigureName],'Interpreter','none'); 
saveas(gcf,'dF HeatMap A', 'jpg');saveas(gcf,'dF HeatMap A', 'fig');
end
if ~isempty(B)
figure; heatmap2(df(:,B)',x2,[],[],'ColorMap',@jet);title(['NoLaser-' FigureName],'Interpreter','none'); 
saveas(gcf,'dF HeatMap B', 'jpg');saveas(gcf,'dF HeatMap B', 'fig');
end


figure;
if ~isempty(A)
subplot(2,1,1);h1=heatmap(df(:,A)','Colormap', jet, 'ColorbarVisible', 'on', 'XLabel', 'Time', 'YLabel', 'Trials');h1.Title='Laser';
end
if ~isempty(B)
subplot(2,1,2);h2=heatmap(df(:,B)','Colormap', jet, 'ColorbarVisible', 'on', 'XLabel', 'Time', 'YLabel', 'Trials');h2.Title='NoLaser' ; 
end


saveas(gcf,'dF HeatMap All Trials', 'jpg');saveas(gcf,'dF HeatMap All Trials', 'fig');
figure;plot(x2,mean(df(:,A),2)-median(mean(df(:,A),2,'omitnan'))); title(FigureName,'Interpreter','none');
saveas(gcf,'dF Mean Trace Laser', 'jpg');saveas(gcf,'dF Mean Trace Laser', 'fig');
figure;plot(x2,mean(df(:,B),2)-median(mean(df(:,B),2,'omitnan'))); title(FigureName,'Interpreter','none');
saveas(gcf,'dF Mean Trace NoLaser', 'jpg');saveas(gcf,'dF Mean Trace NoLaser', 'fig');
figure;plot(x2,mean(df(:,A),2)-median(mean(df(:,A),2)),'b');hold on;
plot(x2,mean(df(:,B),2)-median(mean(df(:,B),2)),'k');
saveas(gcf,'Comparision Average dF Trials with or without Laser', 'jpg');saveas(gcf,'Comparision Average dF Trials with or without Laser', 'fig')

figure;plot(x2,mean(control_df(:,A),2)-median(mean(control_df(:,A),2)),'b');hold on;
plot(x2,mean(control_df(:,B),2)-median(mean(control_df(:,B),2)),'k');
saveas(gcf,'Comparision Average dF Trials with or without Laser Control Channel', 'jpg');
saveas(gcf,'Comparision Average dF Trials with or without Laser Control Channel', 'fig')
 hold off;

 %%
 Lick_Index=1;
for n=1:length(B)
    n1=B(n);
    
    if isfield(SessionData.RawEvents.Trial{1,n1}.Events,'Port8Out')
        Licks_NoLaser{n}=SessionData.RawEvents.Trial{1,n1}.Events.Port8Out;
        nLicks=length(SessionData.RawEvents.Trial{1,n1}.Events.Port8Out);
        Trial_Index_NoLaser(Lick_Index:Lick_Index+nLicks-1)=n;
        Lick_Index=Lick_Index+nLicks;
        
    else
        Licks_NoLaser{n}=[];
    end
end

Lick_Index=1;
for n=1:length(A)
    n1=A(n);
    if isfield(SessionData.RawEvents.Trial{1,n1}.Events,'Port8Out')
        Licks_Laser{n}=SessionData.RawEvents.Trial{1,n1}.Events.Port8Out;
        nLicks=length(SessionData.RawEvents.Trial{1,n1}.Events.Port8Out);
        Trial_Index_Laser(Lick_Index:Lick_Index+nLicks-1)=n;
        Lick_Index=Lick_Index+nLicks;
    else
        Licks_Laser{n}=[];
    end
end


figure;
subplot(2,1,2);
sz = 5;
scatter (cell2mat(Licks_NoLaser)-10,Trial_Index_NoLaser,sz,'filled','s','Markerfacecolor', 'black');
axis ([-10, 20 ,0,30]);
xlabel('Time (s)');
ylabel ('Trials');
subplot(2,1,1);
scatter (cell2mat(Licks_Laser)-10,Trial_Index_Laser,sz,'filled','s','Markerfacecolor', 'green');
axis ([-10, 20 ,0,30]);
xlabel('Time (s)');
ylabel ('Trials');
saveas(gcf,[name '-Raster'], 'jpg');
saveas(gcf,[name '-Raster'], 'fig');


Lick_Index=1;
for n=1:length(B)
    n1=B(n);
    
    if isfield(SessionData.RawEvents.Trial{1,n1}.Events,'Port8Out')
        Licks_NoLaser{n}=SessionData.RawEvents.Trial{1,n1}.Events.Port8Out;
        nLicks=length(SessionData.RawEvents.Trial{1,n1}.Events.Port8Out);
        Trial_Index_NoLaser(Lick_Index:Lick_Index+nLicks-1)=n;
        Lick_Index=Lick_Index+nLicks;
        
    else
        Licks_NoLaser{n}=[];
    end
end

Lick_Index=1;
for n=1:length(A)
    n1=A(n);
    if isfield(SessionData.RawEvents.Trial{1,n1}.Events,'Port8Out')
        Licks_Laser{n}=SessionData.RawEvents.Trial{1,n1}.Events.Port8Out;
        nLicks=length(SessionData.RawEvents.Trial{1,n1}.Events.Port8Out);
        Trial_Index_Laser(Lick_Index:Lick_Index+nLicks-1)=n;
        Lick_Index=Lick_Index+nLicks;
    else
        Licks_Laser{n}=[];
    end
end

x=linspace(-10,20,150);
y1=5*hist(cell2mat(Licks_NoLaser)-10,x)/numel(B);
y2=5*hist(cell2mat(Licks_Laser)-10,x)/numel(A);
figure;
subplot(2,1,1);
bar(x,y1,'k');
axis ([-10, 20, 0,10]);
xlabel('Time (s)');
ylabel('Lick rate (Hz)');
subplot(2,1,2);
bar(x,y2,'g');
axis ([-10, 20, 0,10]);
xlabel('Time (s)');
ylabel('Lick rate (Hz)');
saveas(gcf,[name '-PSTH'], 'jpg');
saveas(gcf,[name '-PSTH'], 'fig');
figure;
plot(x,y1,'k');hold on;
plot(x,y2,'g'); hold off;
axis ([-10, 20, 0,10]);
xlabel('Time (s)');
ylabel('Lick rate (Hz)');
saveas(gcf,[name '-PSTH2'], 'jpg');
saveas(gcf,[name '-PSTH2'], 'fig');
%%
df_Laser1=mean(df(201:250,A));
df_NoLaser1=mean(df(201:250,B));
[h,p_mean,ci,stats]=ttest2(df_Laser1,df_NoLaser1)

%%
df_Laser2=max(df(201:250,A));
df_NoLaser2=max(df(201:250,B));
[h,p_peak,ci,stats]=ttest2(df_Laser2,df_NoLaser2)
%%

close all;
filename = [char(name) '_all_variables.mat'];
save (filename);

end
