%% pupil size analysis

clear all
sample_rate = 120;
VideoFolder = 'data folder'; % enter the directory of your data

cd(VideoFolder) 
DirList = dir;
all_dir = DirList([DirList(:).isdir]);
nTrials =40;

TTL_all = [];
for i = 1:40
    filename = ['PG2gpio',num2str(i),'.csv'];
    SST_temp = load(filename);
    temp2 =  SST_temp(:,2);
    TTL_all = [TTL_all;temp2 ];
end

 Eyeblink_folder = [VideoFolder];
cd(Eyeblink_folder) 
filename = 'data.xlsx';
data = xlsread(filename);

area_data = data(:,5);
ind = find(isnan(area_data));
area_data(ind) = median(area_data(~isnan(area_data)));

n = 1;
m = 1;
for j = 1:length(area_data)
    if TTL_all(j) == 1
       Area(m,n) = area_data(j);
       n = n + 1;
    elseif TTL_all(j) == 0 & TTL_all(j+1) == 1
       m = m + 1; 
       n = 1;
    end
end

A0 = median(Area(:,1:14*sample_rate),2);
A00 = repmat(A0,1,size(Area,2));
DeltaAreaOverArea = (Area-A00)./A00;

h1 = figure; imagesc(DeltaAreaOverArea,[-1 1])
colormap('jet')
xlabel('Time (s)','fontsize',10)
ylabel('Trial #','fontsize',10)
set(gca,'Ydir','reverse')
set(gca,'XTick',6*sample_rate+1)
set(gca,'XTickLabel',[0])
set(gca,'YTick',[1])
set(gca,'YTickLabel',[1])
set(gca,'TickDir','out');